#!/usr/bin/perl -w
#
# Freenet CGI Request Client v0.0.1
#
# Copyright (C) 1999 Steven Hazel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# see http://freenet.on.openproject.net for more info on Freenet
#

use strict;
use Socket;
my ($remote,$port, $iaddr, $paddr, $proto, $line, $insert, $request, $myhost, $myport, $key, $hop, $message, $id, $pid, $pair, $name, $value, $buffer);

sub usage {
    print "Content-type: text/plain\n\n";
    print "usage: remote=ADDRESS port=PORT hops=HopsToLive key=KEY";
    exit;
}

# grab anything sent to this script via POST or GET
# and put it in a mapping called $FORM

$buffer = "";
if (lc(defined($ENV{'REQUEST_METHOD'})) eq "get") { $buffer = defined($ENV{'QUERY_STRING'}); }
else { read(STDIN, $buffer, defined($ENV{'CONTENT_LENGTH'})); }

my @nvpairs = split(/&/, $buffer);
my %FORM = ();
foreach $pair (@nvpairs)
{
	($name, $value) = split(/=/, $pair); 

	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

        $FORM{$name}=$value;
}

$port = $FORM{'port'} || 10001;
$remote = $FORM{'remote'} || 'localhost';
$hop = $FORM{'hop'} || 256;

$key = $ENV{'PATH_INFO'};
$key = substr($key, 1);
$key =~ tr/+/ /;
$key =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

$key || usage;

print "Content-type: text/plain\n\n";

$message = "DataRequest\n";

chop($myhost = `hostname`);
$myhost = inet_ntoa(scalar(gethostbyname($myhost)));
$myport = 11111;

$message .= "Source-" . (5 + length($myhost) + length($myport)) . ":tcp/$myhost:$myport\n";

$message .= "SearchKey-" . length($key) . ":$key\n";
while (length($id .= int(rand(9))) < 19) {next};
$message .= "UniqueID-" . length($id) . ":$id\n";
$message .= "HopsToLive-" . length($hop) . ":$hop\n";

if ($port =~ /\D/) { $port = getservbyname($port, 'tcp') }
die "No port" unless $port;
$iaddr   = inet_aton($remote) || die "no host: $remote";
$paddr   = sockaddr_in($port, $iaddr);
$proto   = getprotobyname('tcp');

# start listening for the impending DataReply connection, so we can be
# sure not to miss it.
socket(Server, PF_INET, SOCK_STREAM, $proto) || die "socket: $!";
setsockopt(Server, SOL_SOCKET, SO_REUSEADDR, pack("l", 1)) || die "setsockopt: $!";
bind(Server, sockaddr_in($myport, INADDR_ANY)) || die "bind: $!";
listen(Server,SOMAXCONN) || die "listen: $!";     

# now open the server and send the DataRequest
socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || die "socket: $!";
connect(SOCK, $paddr) || die "connect: $!";

print SOCK $message;

close (SOCK) || die "close: $!";

# accept the connection for the DataReply, and dump it to stdout.
$paddr = accept(Client,Server);
    
if (<Client> =~ /DataReply/) {
    until (<Client> =~ /:$/) {next};
    (<Client>); #get rid of one empty line
    while (defined(my $line = <Client>)) {
        print ($line);
    }	
}

close Client;
exit;
